# Class JarOutputStream

java.lang.Object
java.io.OutputStream
java.io.FilterOutputStream
java.util.zip.DeflaterOutputStream
java.util.zip.ZipOutputStream
java.util.jar.JarOutputStream

All Implemented Interfaces:
  `Closeable, Flushable, AutoCloseable`

public class JarOutputStream extends ZipOutputStream
The `JarOutputStream` class is used to write the contents of a JAR file to any output stream. It extends the class `java.util.zip.ZipOutputStream` with support for writing an optional `Manifest` entry. The `Manifest` can be used to specify meta-information about the JAR file and its entries.

Unless otherwise noted, passing a `null` argument to a constructor or method in this class will cause a `NullPointerException` to be thrown.

Since:
  1.2
See Also:
  - `Manifest`
  - `ZipOutputStream`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`CENATT`
Central directory (CEN) header internal file attributes field offset.
`static final int`
`CENATX`
Central directory (CEN) header external file attributes field offset.
`static final int`
`CENCOM`
Central directory (CEN) header comment length field offset.
`static final int`
`CENCRC`
Central directory (CEN) header uncompressed file crc-32 value field offset.
`static final int`
`CENDSK`
Central directory (CEN) header disk number start field offset.
`static final int`
`CENEXT`
Central directory (CEN) header extra field length field offset.
`static final int`
`CENFLG`
Central directory (CEN) header encrypt, decrypt flags field offset.
`static final int`
`CENHDR`
Central directory (CEN) header size in bytes (including signature).
`static final int`
`CENHOW`
Central directory (CEN) header compression method field offset.
`static final int`
`CENLEN`
Central directory (CEN) header uncompressed size field offset.
`static final int`
`CENNAM`
Central directory (CEN) header filename length field offset.
`static final int`
`CENOFF`
Central directory (CEN) header LOC header offset field offset.
`static final long`
`CENSIG`
Central directory (CEN) header signature.
`static final int`
`CENSIZ`
Central directory (CEN) header compressed size field offset.
`static final int`
`CENTIM`
Central directory (CEN) header modification time field offset.
`static final int`
`CENVEM`
Central directory (CEN) header version made by field offset.
`static final int`
`CENVER`
Central directory (CEN) header version needed to extract field offset.
`static final int`
`ENDCOM`
End of central directory (END) header ZIP file comment length field offset.
`static final int`
`ENDHDR`
End of central directory (END) header size in bytes (including signature).
`static final int`
`ENDOFF`
End of central directory (END) header offset for the first CEN header field offset.
`static final long`
`ENDSIG`
End of central directory (END) header signature.
`static final int`
`ENDSIZ`
End of central directory (END) header central directory size in bytes field offset.
`static final int`
`ENDSUB`
End of central directory (END) header number of entries on this disk field offset.
`static final int`
`ENDTOT`
End of central directory (END) header total number of entries field offset.
`static final int`
`EXTCRC`
Extra local (EXT) header uncompressed file crc-32 value field offset.
`static final int`
`EXTHDR`
Extra local (EXT) header size in bytes (including signature).
`static final int`
`EXTLEN`
Extra local (EXT) header uncompressed size field offset.
`static final long`
`EXTSIG`
Extra local (EXT) header signature.
`static final int`
`EXTSIZ`
Extra local (EXT) header compressed size field offset.
`static final int`
`LOCCRC`
Local file (LOC) header uncompressed file crc-32 value field offset.
`static final int`
`LOCEXT`
Local file (LOC) header extra field length field offset.
`static final int`
`LOCFLG`
Local file (LOC) header general purpose bit flag field offset.
`static final int`
`LOCHDR`
Local file (LOC) header size in bytes (including signature).
`static final int`
`LOCHOW`
Local file (LOC) header compression method field offset.
`static final int`
`LOCLEN`
Local file (LOC) header uncompressed size field offset.
`static final int`
`LOCNAM`
Local file (LOC) header filename length field offset.
`static final long`
`LOCSIG`
Local file (LOC) header signature.
`static final int`
`LOCSIZ`
Local file (LOC) header compressed size field offset.
`static final int`
`LOCTIM`
Local file (LOC) header modification time field offset.
`static final int`
`LOCVER`
Local file (LOC) header version needed to extract field offset.

### Fields declared in class ZipOutputStream

`DEFLATED, STORED`
Modifier and Type
Field
Description
`static final int`
`DEFLATED`
Compression method for compressed (DEFLATED) entries.
`static final int`
`STORED`
Compression method for uncompressed (STORED) entries.

### Fields declared in class DeflaterOutputStream

`buf, def`
Modifier and Type
Field
Description
`protected byte[]`
`buf`
Output buffer for writing compressed data.
`protected Deflater`
`def`
Compressor for this stream.

### Fields declared in class FilterOutputStream

`out`
Modifier and Type
Field
Description
`protected OutputStream`
`out`
The underlying output stream to be filtered.

## Constructor Summary

Constructors
Constructor
Description
`JarOutputStream(OutputStream out)`
Creates a new `JarOutputStream` with no manifest.
`JarOutputStream(OutputStream out, Manifest man)`
Creates a new `JarOutputStream` with the specified `Manifest`.

## Method Summary

Modifier and Type
Method
Description
`void`
`putNextEntry(ZipEntry ze)`
Begins writing a new JAR file entry and positions the stream to the start of the entry data.

### Methods declared in class ZipOutputStream

`close, closeEntry, finish, setComment, setLevel, setMethod, write`
Modifier and Type
Method
Description
`void`
`close()`
Closes the underlying stream and the stream being filtered after the contents of the ZIP output stream are fully written.
`void`
`closeEntry()`
Closes the current ZIP entry and positions the stream for writing the next entry.
`void`
`finish()`
Finishes writing the contents of the ZIP output stream without closing the underlying stream.
`void`
`setComment(String comment)`
Sets the ZIP file comment.
`void`
`setLevel(int level)`
Sets the compression level for subsequent entries which are DEFLATED.
`void`
`setMethod(int method)`
Sets the default compression method for subsequent entries.
`void`
`write(byte[] b, int off, int len)`
Writes an array of bytes to the current ZIP entry data.

### Methods declared in class DeflaterOutputStream

`deflate, flush, write`
Modifier and Type
Method
Description
`protected void`
`deflate()`
Writes next block of compressed data to the output stream.
`void`
`flush()`
Flushes the compressed output stream.
`void`
`write(int b)`
Writes a byte to the compressed output stream.

### Methods declared in class FilterOutputStream

`write`
Modifier and Type
Method
Description
`void`
`write(byte[] b)`
Writes `b.length` bytes to this output stream.

### Methods declared in class OutputStream

`nullOutputStream`
Modifier and Type
Method
Description
`static OutputStream`
`nullOutputStream()`
Returns a new `OutputStream` which discards all bytes.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### LOCSIG

static final long LOCSIG
Local file (LOC) header signature.

See Also:
  - Constant Field Values

### EXTSIG

static final long EXTSIG
Extra local (EXT) header signature.

See Also:
  - Constant Field Values

### CENSIG

static final long CENSIG
Central directory (CEN) header signature.

See Also:
  - Constant Field Values

### ENDSIG

static final long ENDSIG
End of central directory (END) header signature.

See Also:
  - Constant Field Values

### LOCHDR

static final int LOCHDR
Local file (LOC) header size in bytes (including signature).

See Also:
  - Constant Field Values

### EXTHDR

static final int EXTHDR
Extra local (EXT) header size in bytes (including signature).

See Also:
  - Constant Field Values

### CENHDR

static final int CENHDR
Central directory (CEN) header size in bytes (including signature).

See Also:
  - Constant Field Values

### ENDHDR

static final int ENDHDR
End of central directory (END) header size in bytes (including signature).

See Also:
  - Constant Field Values

### LOCVER

static final int LOCVER
Local file (LOC) header version needed to extract field offset.

See Also:
  - Constant Field Values

### LOCFLG

static final int LOCFLG
Local file (LOC) header general purpose bit flag field offset.

See Also:
  - Constant Field Values

### LOCHOW

static final int LOCHOW
Local file (LOC) header compression method field offset.

See Also:
  - Constant Field Values

### LOCTIM

static final int LOCTIM
Local file (LOC) header modification time field offset.

See Also:
  - Constant Field Values

### LOCCRC

static final int LOCCRC
Local file (LOC) header uncompressed file crc-32 value field offset.

See Also:
  - Constant Field Values

### LOCSIZ

static final int LOCSIZ
Local file (LOC) header compressed size field offset.

See Also:
  - Constant Field Values

### LOCLEN

static final int LOCLEN
Local file (LOC) header uncompressed size field offset.

See Also:
  - Constant Field Values

### LOCNAM

static final int LOCNAM
Local file (LOC) header filename length field offset.

See Also:
  - Constant Field Values

### LOCEXT

static final int LOCEXT
Local file (LOC) header extra field length field offset.

See Also:
  - Constant Field Values

### EXTCRC

static final int EXTCRC
Extra local (EXT) header uncompressed file crc-32 value field offset.

See Also:
  - Constant Field Values

### EXTSIZ

static final int EXTSIZ
Extra local (EXT) header compressed size field offset.

See Also:
  - Constant Field Values

### EXTLEN

static final int EXTLEN
Extra local (EXT) header uncompressed size field offset.

See Also:
  - Constant Field Values

### CENVEM

static final int CENVEM
Central directory (CEN) header version made by field offset.

See Also:
  - Constant Field Values

### CENVER

static final int CENVER
Central directory (CEN) header version needed to extract field offset.

See Also:
  - Constant Field Values

### CENFLG

static final int CENFLG
Central directory (CEN) header encrypt, decrypt flags field offset.

See Also:
  - Constant Field Values

### CENHOW

static final int CENHOW
Central directory (CEN) header compression method field offset.

See Also:
  - Constant Field Values

### CENTIM

static final int CENTIM
Central directory (CEN) header modification time field offset.

See Also:
  - Constant Field Values

### CENCRC

static final int CENCRC
Central directory (CEN) header uncompressed file crc-32 value field offset.

See Also:
  - Constant Field Values

### CENSIZ

static final int CENSIZ
Central directory (CEN) header compressed size field offset.

See Also:
  - Constant Field Values

### CENLEN

static final int CENLEN
Central directory (CEN) header uncompressed size field offset.

See Also:
  - Constant Field Values

### CENNAM

static final int CENNAM
Central directory (CEN) header filename length field offset.

See Also:
  - Constant Field Values

### CENEXT

static final int CENEXT
Central directory (CEN) header extra field length field offset.

See Also:
  - Constant Field Values

### CENCOM

static final int CENCOM
Central directory (CEN) header comment length field offset.

See Also:
  - Constant Field Values

### CENDSK

static final int CENDSK
Central directory (CEN) header disk number start field offset.

See Also:
  - Constant Field Values

### CENATT

static final int CENATT
Central directory (CEN) header internal file attributes field offset.

See Also:
  - Constant Field Values

### CENATX

static final int CENATX
Central directory (CEN) header external file attributes field offset.

See Also:
  - Constant Field Values

### CENOFF

static final int CENOFF
Central directory (CEN) header LOC header offset field offset.

See Also:
  - Constant Field Values

### ENDSUB

static final int ENDSUB
End of central directory (END) header number of entries on this disk field offset.

See Also:
  - Constant Field Values

### ENDTOT

static final int ENDTOT
End of central directory (END) header total number of entries field offset.

See Also:
  - Constant Field Values

### ENDSIZ

static final int ENDSIZ
End of central directory (END) header central directory size in bytes field offset.

See Also:
  - Constant Field Values

### ENDOFF

static final int ENDOFF
End of central directory (END) header offset for the first CEN header field offset.

See Also:
  - Constant Field Values

### ENDCOM

static final int ENDCOM
End of central directory (END) header ZIP file comment length field offset.

See Also:
  - Constant Field Values

## Constructor Details

### JarOutputStream

public JarOutputStream(OutputStream out, Manifest man) throws IOException
Creates a new `JarOutputStream` with the specified `Manifest`. The manifest is written as the first entry to the output stream.

Parameters:
  `out` - the actual output stream
  `man` - the optional `Manifest`
Throws:
  `IOException` - if an I/O error has occurred

### JarOutputStream

public JarOutputStream(OutputStream out) throws IOException
Creates a new `JarOutputStream` with no manifest.

Parameters:
  `out` - the actual output stream
Throws:
  `IOException` - if an I/O error has occurred

## Method Details

### putNextEntry

public void putNextEntry(ZipEntry ze) throws IOException
Begins writing a new JAR file entry and positions the stream to the start of the entry data. This method will also close any previous entry.

The default compression method will be used if no compression method was specified for the entry. When writing a compressed (DEFLATED) entry, and the compressed size has not been explicitly set with the `ZipEntry.setCompressedSize(long)` method, then the compressed size will be set to the actual compressed size after deflation.

The current time will be used if the entry has no set modification time.

Overrides:
  `putNextEntry` in class `ZipOutputStream`
Parameters:
  `ze` - the ZIP/JAR entry to be written
Throws:
  `ZipException` - if a ZIP error has occurred
  `IOException` - if an I/O error has occurred